Loading...
Searching...
No Matches
BoxStencil< GridT > Class Template Reference

`#include <nanovdb/util/Stencils.h>`

Inheritance diagram for BoxStencil< GridT >:

## Public Types

using | GridType = GridT
using | TreeType = typename GridT::TreeType
using | ValueType = typename GridT::ValueType
using | AccessorType

## Public Member Functions

| BoxStencil (const GridType &grid)
template<int i, int j, int k>
unsigned int | pos () const
| Return linear offset for the specified stencil point relative to its center.
bool | intersects (ValueType isoValue=ValueType(0)) const
| Return true if the center of the stencil intersects the.
ValueType | interpolation (const Vec3< ValueType > &xyz) const
| Return the trilinear interpolation at the normalized position.
Vec3< ValueType > | gradient (const Vec3< ValueType > &xyz) const
| Return the gradient in world space of the trilinear interpolation kernel.
void | moveTo (const Coord &ijk)
| Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors.
const ValueType & | getValue (unsigned int pos=0) const
| Return the value from the stencil buffer with linear offset pos.
void | setValue (const ValueType &value)
| Set the value at the specified location relative to the center of the stencil.
ValueType | mean () const
| Return the mean value of the current stencil.
ValueType | min () const
| Return the smallest value in the stencil buffer.
ValueType | max () const
| Return the largest value in the stencil buffer.
const Coord & | getCenterCoord () const
| Return the coordinates of the center point of the stencil.
const ValueType & | getCenterValue () const
| Return the value at the center of the stencil.
bool | intersects (const ValueType &isoValue=ValueType(0)) const
| Return true if the center of the stencil intersects the iso-contour specified by the isoValue.
Mask | intersectionMask (ValueType isoValue=ValueType(0)) const
| Return true a bit-mask where the 6 lower bits indicates if the center of the stencil intersects the iso-contour specified by the isoValue.
const GridType & | grid () const
| Return a const reference to the grid from which this stencil was constructed.
const AccessorType & | accessor () const
| Return a const reference to the ValueAccessor associated with this Stencil.

## Static Public Member Functions

static int | size ()
| Return the size of the stencil buffer.

## Static Public Attributes

static constexpr int | SIZE = 8

## Protected Attributes

const GridType * | mGrid

## Friends

template<typename, int, typename>
class | BaseStencil

## Member Typedef Documentation

## AccessorType

using AccessorType

inherited

## GridType

template<typename GridT>

using GridType = GridT

## TreeType

template<typename GridT>

using TreeType = typename GridT::TreeType

## ValueType

template<typename GridT>

using ValueType = typename GridT::ValueType

## Constructor & Destructor Documentation

## BoxStencil()

template<typename GridT>

BoxStencil | ( | const GridType & | grid | ) |

inline

## Member Function Documentation

## accessor()

const AccessorType & accessor | ( |  | ) | const

inline inherited

Return a const reference to the ValueAccessor associated with this Stencil.

## getCenterCoord()

const Coord & getCenterCoord | ( |  | ) | const

inline inherited

Return the coordinates of the center point of the stencil.

## getCenterValue()

const ValueType & getCenterValue | ( |  | ) | const

inline inherited

Return the value at the center of the stencil.

## getValue()

const ValueType & getValue | ( | unsigned int | pos = 0 | ) | const

inline inherited

Return the value from the stencil buffer with linear offset pos.

Note
  The default (pos = 0) corresponds to the first element which is typically the center point of the stencil.

## gradient()

template<typename GridT>

Vec3< ValueType > gradient | ( | const Vec3< ValueType > & | xyz | ) | const

inline

Return the gradient in world space of the trilinear interpolation kernel.

Parameters

  xyz | Floating point coordinate position.

Warning
  It is assumed that the stencil has already been moved to the relevant voxel position, e.g. using moveTo(xyz).

Note
  Computed as partial derivatives of the trilinear interpolation kernel: v000 (1-u)(1-v)(1-w) + v001 (1-u)(1-v)w + v010 (1-u)v(1-w) + v011 (1-u)vw
  - v100 u(1-v)(1-w) + v101 u(1-v)w + v110 uv(1-w) + v111 uvw

## grid()

const GridType & grid | ( |  | ) | const

inline inherited

Return a const reference to the grid from which this stencil was constructed.

## interpolation()

template<typename GridT>

ValueType interpolation | ( | const Vec3< ValueType > & | xyz | ) | const

inline

Return the trilinear interpolation at the normalized position.

Parameters

  xyz | Floating point coordinate position. Index space and NOT world space.

Warning
  It is assumed that the stencil has already been moved to the relevant voxel position, e.g. using moveTo(xyz).

Note
  Trilinear interpolation kernal reads as: v000 (1-u)(1-v)(1-w) + v001 (1-u)(1-v)w + v010 (1-u)v(1-w) + v011 (1-u)vw
  - v100 u(1-v)(1-w) + v101 u(1-v)w + v110 uv(1-w) + v111 uvw

## intersectionMask()

Mask intersectionMask | ( | ValueType | isoValue = ValueType(0) | ) | const

inline inherited

Return true a bit-mask where the 6 lower bits indicates if the center of the stencil intersects the iso-contour specified by the isoValue.

Note
  There are 2^6 = 64 different possible cases, including no intersections!

The ordering of bit mask is ( -x, +x, -y, +y, -z, +z ), so to check if there is an intersection in -y use (mask & (1u<<2)) where mask is ther return value from this function. To check if there are any intersections use mask!=0u, and for no intersections use mask==0u. To count the number of intersections use __builtin_popcount(mask).

## intersects() [1/2]

bool intersects | ( | const ValueType & | isoValue = ValueType(0) | ) | const

inline inherited

Return true if the center of the stencil intersects the iso-contour specified by the isoValue.

## intersects() [2/2]

template<typename GridT>

bool intersects | ( | ValueType | isoValue = ValueType(0) | ) | const

inline

Return true if the center of the stencil intersects the.

iso-contour specified by the isoValue

## max()

ValueType max | ( |  | ) | const

inline inherited

Return the largest value in the stencil buffer.

## mean()

ValueType mean | ( |  | ) | const

inline inherited

Return the mean value of the current stencil.

## min()

ValueType min | ( |  | ) | const

inline inherited

Return the smallest value in the stencil buffer.

## moveTo()

void moveTo | ( | const Coord & | ijk | ) |

inline inherited

Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors.

Parameters

  ijk | Index coordinates of stencil center

## pos()

template<typename GridT>
template<int i, int j, int k>

unsigned int pos | ( |  | ) | const

inline

Return linear offset for the specified stencil point relative to its center.

## setValue()

void setValue | ( | const ValueType & | value | ) |

inline inherited

Set the value at the specified location relative to the center of the stencil.

## size()

int size | ( |  | ) |

inline static inherited

Return the size of the stencil buffer.

## Friends And Related Symbol Documentation

## BaseStencil

template<typename GridT>
template<typename, int, typename>

friend class BaseStencil

friend

## Member Data Documentation

## mGrid

const GridType* mGrid

protected inherited

## SIZE

template<typename GridT>

int SIZE = 8

static constexpr